/*
 * uhub - A tiny ADC p2p connection hub
 * Copyright (C) 2007, Jan Vidar Krey
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

#ifndef HAVE_uhub_LOG_H
#define HAVE_uhub_LOG_H

enum log_verbosity {
	log_fatal    = 0,
	log_error    = 1,
	log_warning  = 2,
	log_info     = 3,
	log_debug    = 4,
	log_trace    = 5,
	log_dump     = 6,
};

extern void uhub_set_log_verbosity(int log_verbosity);
extern void uhub_log(int log_verbosity, const char *format, ...);

#endif /* HAVE_uhub_LOG_H */
